#include <stdio.h>
#include <stdlib.h>
#include <time.h>


unsigned long int EncodeBCH(unsigned long int);
unsigned char CorrectBCH(unsigned long int *);


void main(void)
{
unsigned char ci;
unsigned long int data=0;
unsigned long int encoded_data,corrupt_data,corrected_data,decoded_data;

randomize();


// Generate random data

for(ci=0;ci<3;ci++)
 {
 data=(data<<8)^rand();
 }

// truncate to 21 bit

data&=0x1ffffful;

// encode to BCH 32.21

encoded_data=EncodeBCH(data);

// Corrupt data (2 random errors)

corrupt_data = encoded_data^ (1ul<<(0x1f&rand()));

corrupt_data^= (1ul<<(0x1f&rand()));


// Correct data

corrected_data = corrupt_data;

ci=CorrectBCH(&corrected_data);

// Decode data

decoded_data = corrected_data >> 11;

printf("\n\n Data=%08lxh",data);
printf("\n Encoded Data=%08lxh",encoded_data);
printf("\n Corrupt Data=%08lxh",corrupt_data);
printf("\n Corrected Data=%08lxh (Errors=%d)",corrected_data,ci);
printf("\n Decoded Data=%08lxh",decoded_data);

}
