/*
Function encodes 21-bit data word into 32-bit extended BCH 32.21 word
*/

unsigned long int EncodeBCH(unsigned long int data)
{
unsigned char ci;
unsigned long int ltmp;

ltmp=data;

// divide by polynom

for(ci=0;ci<21;ci++)
 {

 ltmp<<=1;

 if(ltmp&0x200000ul)
  {
  ltmp^=0x1b4800ul;
  }

 }

// allign the remainder

ltmp>>=10;
ltmp&=0x7fe;

// add data

ltmp|=data<<11;
data=ltmp;

// calculate parity

ci=0;
while(ltmp)
 {
 ci^=ltmp&1;
 ltmp>>=1;
 }

// add parity

data|=ci;

return data;
}
